// DpcStackGrowerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DpcStackGrower.h"
#include "DpcStackGrowerDlg.h"

#include "InstallDriver.h"
#include "..\Include\IOCTLs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDpcStackGrowerDlg dialog

CDpcStackGrowerDlg::CDpcStackGrowerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDpcStackGrowerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDpcStackGrowerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDpcStackGrowerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDpcStackGrowerDlg)
	DDX_Control(pDX, IDC_EVENTS, m_wndEvents);
	DDX_Control(pDX, IDC_DIM, m_wndDim);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDpcStackGrowerDlg, CDialog)
	//{{AFX_MSG_MAP(CDpcStackGrowerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDpcStackGrowerDlg message handlers

BOOL CDpcStackGrowerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize controls.

	m_wndDim.SetWindowText( "128" );

	// Return.
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDpcStackGrowerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDpcStackGrowerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDpcStackGrowerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // //
// // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // //
// // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // //

VOID CDpcStackGrowerDlg::PrintEvent( CONST CHAR* pszStr )
{
	CString		str;
	m_wndEvents.GetWindowText( str );
	m_wndEvents.SetWindowText( ( str + ( str.GetLength() == 0 ? "" : "\r\n" ) + pszStr ).GetBuffer( 0 ) );

	m_wndEvents.SetSel( 0x7f000000, 0x7f000000 );

	return;
}

void CDpcStackGrowerDlg::OnOK() 
{
	// Get the size.

	CHAR			szDim[ MAX_PATH ];
	m_wndDim.GetWindowText( szDim, sizeof( szDim ) );

	ULONG			ulDim = ::strtoul( szDim, NULL, 10 );
	if ( ulDim < 12 || ulDim > 1024 )
	{
		PrintEvent( "Invalid dim entered !" );
		return;
	}

	// Load the device driver.

	BOOL		bDriverFileCreatRes = ::CreateDriverFileFromAppResources( ::AfxGetResourceHandle (), MAKEINTRESOURCE( IDR_SYSFILE ), "SYSFILE", "vpcdpcsg.sys" );
	if ( bDriverFileCreatRes == FALSE )
	{
		PrintEvent( "::CreateDriverFileFromAppResources failed !" );
		return;
	}

	HANDLE		hDevice = NULL;
	BOOL		bInstallDriverRes = ::StartVersionedDeviceDriver( & hDevice, "vpcdpcsg.sys", "vpcdpcsg", IOCTL_DPCSTKGRNT_GET_VERSION, _VPCDpcSG_DRIVER_VERSION_, NULL );
	if ( bInstallDriverRes == FALSE || hDevice == NULL )
	{
		PrintEvent( "::StartVersionedDeviceDriver failed !" );
		return;
	}

	// Delete the sys file.

	::DeleteDriverFile( "vpcdpcsg.sys" );

	// Start.

	DWORD		dwBytesReturned = 0;

	INITIALIZE_INPUT			iiInput;
	INITIALIZE_OUTPUT			ioOutput;

	::memset( & iiInput, 0, INITIALIZE_INPUT_SIZE );
	::memset( & ioOutput, 0, INITIALIZE_OUTPUT_SIZE );

	iiInput.ulStackSizeInKBytes = ulDim;

	BOOL		bIoctlRes = ::DeviceIoControl( hDevice, IOCTL_DPCSTKGRNT_INITIALIZE,
		& iiInput, INITIALIZE_INPUT_SIZE,
		& ioOutput, INITIALIZE_OUTPUT_SIZE,
		& dwBytesReturned, NULL );

	::CloseHandle( hDevice );

	if ( bIoctlRes && ioOutput.bSucceeded )
	{
		CHAR		sz[ MAX_PATH ];
		::sprintf( sz, "KiRetireDpcList address: %X.", ioOutput.dwKiRetireDpcListFnAddr );

		PrintEvent( "OPERATION SUCCEEDED !" );
		PrintEvent( sz );
	}
	else
	{
		PrintEvent( "OPERATION FAILED !" );
		PrintEvent( "Make sure that:" );
		PrintEvent( "(x) Your system is supported by this release of the program (check out my site at www.VitoPlantamura.COM for more info)." );
		PrintEvent( "(x) \"HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Memory Management\\EnforceWriteProtection\" is set to 0." );
		PrintEvent( "(x) YOU HAVE REBOOTED after having changed the registry value above." );
		PrintEvent( "(x) you didn't already lauch the program." );
	}

	// Call base.

	//CDialog::OnOK();

	// return.

	return;
}

// // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // //
// // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // //
// // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // // //
